using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using Microsoft.CSharp;
using System.CodeDom.Compiler;
using System.Reflection;

namespace NdisMonitor
{
	/// <summary>
	/// Summary description for CodeWindow.
	/// </summary>
	public class CodeWindow : System.Windows.Forms.Form
	{
		private System.Windows.Forms.ToolBar ctrlToolbar;
		private System.Windows.Forms.TextBox ctrlCodePane;
		private System.Windows.Forms.ToolBarButton ctrlCompile;
		private System.Windows.Forms.ImageList ilToolbarImages;
		private System.Windows.Forms.StatusBar ctrlStatusBar;
		private System.Windows.Forms.ToolBarButton toolBarSep1;
		private System.ComponentModel.IContainer components;

		public CodeWindow( string scriptText )
		{
			_scriptText = scriptText;

			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

			//
			// TODO: Add any constructor code after InitializeComponent call
			//
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if(components != null)
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.components = new System.ComponentModel.Container();
			System.Resources.ResourceManager resources = new System.Resources.ResourceManager(typeof(CodeWindow));
			this.ctrlToolbar = new System.Windows.Forms.ToolBar();
			this.ctrlCompile = new System.Windows.Forms.ToolBarButton();
			this.ilToolbarImages = new System.Windows.Forms.ImageList(this.components);
			this.ctrlCodePane = new System.Windows.Forms.TextBox();
			this.ctrlStatusBar = new System.Windows.Forms.StatusBar();
			this.toolBarSep1 = new System.Windows.Forms.ToolBarButton();
			this.SuspendLayout();
			// 
			// ctrlToolbar
			// 
			this.ctrlToolbar.Appearance = System.Windows.Forms.ToolBarAppearance.Flat;
			this.ctrlToolbar.Buttons.AddRange(new System.Windows.Forms.ToolBarButton[] {
																						   this.ctrlCompile,
																						   this.toolBarSep1});
			this.ctrlToolbar.ButtonSize = new System.Drawing.Size(16, 16);
			this.ctrlToolbar.DropDownArrows = true;
			this.ctrlToolbar.ImageList = this.ilToolbarImages;
			this.ctrlToolbar.Location = new System.Drawing.Point(0, 0);
			this.ctrlToolbar.Name = "ctrlToolbar";
			this.ctrlToolbar.ShowToolTips = true;
			this.ctrlToolbar.Size = new System.Drawing.Size(648, 28);
			this.ctrlToolbar.TabIndex = 0;
			this.ctrlToolbar.ButtonClick += new System.Windows.Forms.ToolBarButtonClickEventHandler(this.ctrlToolbar_ButtonClick);
			// 
			// ctrlCompile
			// 
			this.ctrlCompile.ImageIndex = 0;
			this.ctrlCompile.ToolTipText = "Compile...";
			// 
			// ilToolbarImages
			// 
			this.ilToolbarImages.ImageSize = new System.Drawing.Size(16, 16);
			this.ilToolbarImages.ImageStream = ((System.Windows.Forms.ImageListStreamer)(resources.GetObject("ilToolbarImages.ImageStream")));
			this.ilToolbarImages.TransparentColor = System.Drawing.Color.Transparent;
			// 
			// ctrlCodePane
			// 
			this.ctrlCodePane.AcceptsTab = true;
			this.ctrlCodePane.Anchor = ((System.Windows.Forms.AnchorStyles)((((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom) 
				| System.Windows.Forms.AnchorStyles.Left) 
				| System.Windows.Forms.AnchorStyles.Right)));
			this.ctrlCodePane.Font = new System.Drawing.Font("Courier New", 8.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.ctrlCodePane.Location = new System.Drawing.Point(0, 28);
			this.ctrlCodePane.Multiline = true;
			this.ctrlCodePane.Name = "ctrlCodePane";
			this.ctrlCodePane.ScrollBars = System.Windows.Forms.ScrollBars.Both;
			this.ctrlCodePane.Size = new System.Drawing.Size(648, 323);
			this.ctrlCodePane.TabIndex = 1;
			this.ctrlCodePane.Text = "";
			this.ctrlCodePane.WordWrap = false;
			this.ctrlCodePane.KeyDown += new System.Windows.Forms.KeyEventHandler(this.ctrlCodePane_KeyDown);
			// 
			// ctrlStatusBar
			// 
			this.ctrlStatusBar.Location = new System.Drawing.Point(0, 351);
			this.ctrlStatusBar.Name = "ctrlStatusBar";
			this.ctrlStatusBar.Size = new System.Drawing.Size(648, 22);
			this.ctrlStatusBar.TabIndex = 2;
			this.ctrlStatusBar.Text = "Press Alt+Enter to compile. --Warning-- the script must be compiled at least once" +
				" from this window in order to be used.";
			// 
			// toolBarSep1
			// 
			this.toolBarSep1.Style = System.Windows.Forms.ToolBarButtonStyle.Separator;
			// 
			// CodeWindow
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(648, 373);
			this.Controls.Add(this.ctrlStatusBar);
			this.Controls.Add(this.ctrlCodePane);
			this.Controls.Add(this.ctrlToolbar);
			this.Icon = ((System.Drawing.Icon)(resources.GetObject("$this.Icon")));
			this.Name = "CodeWindow";
			this.StartPosition = System.Windows.Forms.FormStartPosition.CenterScreen;
			this.Text = "C# Code Window";
			this.Closing += new System.ComponentModel.CancelEventHandler(this.CodeWindow_Closing);
			this.Load += new System.EventHandler(this.CodeWindow_Load);
			this.Closed += new System.EventHandler(this.CodeWindow_Closed);
			this.ResumeLayout(false);

		}
		#endregion

		//
		// data.
		//

		protected ErrorsWindow			_dlg = null;

		//
		// return values.
		//

		public Assembly					_retval = null;
		public string					_scriptText = null;
		public bool						_modified = false;

		//
		// methods.
		//

		protected void Compile ()
		{
			// set modified flag.

			_modified = true;

			// compile.

			CSharpCodeProvider		prov = new CSharpCodeProvider ();
			ICodeCompiler			comp = prov.CreateCompiler ();

			CompilerParameters		param = new CompilerParameters ();

			param.GenerateExecutable = false;
			param.GenerateInMemory = true;
			param.IncludeDebugInformation = true;

			param.ReferencedAssemblies.Add( "System.dll" );
			param.ReferencedAssemblies.Add( "System.Data.dll" );
			param.ReferencedAssemblies.Add( "System.Drawing.dll" );
			param.ReferencedAssemblies.Add( "System.Windows.Forms.dll" );
			param.ReferencedAssemblies.Add( "System.XML.dll" );
			param.ReferencedAssemblies.Add( "NmExtension.dll" );

			CompilerResults			res = comp.CompileAssemblyFromSource( param, ctrlCodePane.Text );

			// show errors / warnings.

			_retval = null;

			if ( _dlg != null )
			{
				_dlg.Close ();
				_dlg = null;
			}

			if ( res.Errors.Count == 0 )
			{
				MessageBox.Show( "Compilation successful.", "NDIS Monitor" );
				ctrlCodePane.Modified = false;
				_retval = res.CompiledAssembly;
			}
			else
			{
				_dlg = new ErrorsWindow( res, this );
				_dlg.Show();
			}
		}

		private void ctrlToolbar_ButtonClick(object sender, System.Windows.Forms.ToolBarButtonClickEventArgs e)
		{
			if ( e.Button == ctrlCompile )
				Compile ();
		}

		private void ctrlCodePane_KeyDown(object sender, System.Windows.Forms.KeyEventArgs e)
		{
			if ( e.KeyCode == Keys.Enter && e.Alt == true && e.Control == false && e.Shift == false )
			{
				e.Handled = true;
				Compile ();
			}
		}

		private void CodeWindow_Closed(object sender, System.EventArgs e)
		{
			// close errors window.
			if ( _dlg != null )
			{
				_dlg.Close ();
				_dlg = null;
			}
		}

		public void GoToLine( CompilerError err )
		{
			int				x = err.Column;
			int				y = err.Line;
			string			t = ctrlCodePane.Text;

			int				index = 0;
			foreach( char c in t )
			{
				if ( c == '\r' )
				{
					y --;
					if ( y <= 0 )
						break;
					else
						x = err.Column;
				}
				else if ( c != '\n' )
				{
					x --;
					if ( x <= 0 && y == 1 )
						break;
				}
				index ++;
			}

			ctrlCodePane.SelectionStart = index;
			ctrlCodePane.SelectionLength = 0;
			ctrlCodePane.ScrollToCaret ();
		}

		private void CodeWindow_Closing(object sender, System.ComponentModel.CancelEventArgs e)
		{
			if ( ctrlCodePane.Modified )
			{
				DialogResult		res = MessageBox.Show( "The code pane contents were not compiled and/or there were errors.\r\n\r\nDo you want to exit anyway ?", "NDIS Monitor", MessageBoxButtons.YesNo );
				if ( res == DialogResult.No )
					e.Cancel = true;
			}

			if ( e.Cancel == false )
				_scriptText = ctrlCodePane.Text;
		}

		private void CodeWindow_Load(object sender, System.EventArgs e)
		{
			// init text pane.

			ctrlCodePane.Text = _scriptText;

			ctrlCodePane.SelectionStart = 0;
			ctrlCodePane.SelectionLength = 0;
			ctrlCodePane.ScrollToCaret ();

			// init the code wizard controls.

			Label		wizLab = new Label ();
			wizLab.Text = "Filter code wizard:";

			wizLab.AutoSize = true;
			wizLab.Left = toolBarSep1.Rectangle.Left + toolBarSep1.Rectangle.Width;
			wizLab.Top = ( toolBarSep1.Rectangle.Height - wizLab.Height ) / 2 + 1;

			ctrlToolbar.Controls.Add( wizLab );

			ComboBox	wizCb = new ComboBox ();
			wizCb.DropDownStyle = ComboBoxStyle.DropDownList;
			wizCb.Sorted = false;

			wizCb.Left = wizLab.Left + wizLab.Width;
			wizCb.Width = 430;

			wizCb.Items.Add( " >>> select a filter from the list and press the button / select this option for help <<< " );
			FilterWizard.PopulateCb( wizCb );
			wizCb.SelectedIndex = 0;

			ctrlToolbar.Controls.Add( wizCb );

			LinkLabel		wizBtn = new LinkLabel ();
			wizBtn.LinkClicked += new LinkLabelLinkClickedEventHandler( wizBtn_Click );
			wizBtn.Text = "Create";

			wizBtn.AutoSize = true;
			wizBtn.Left = wizCb.Left + wizCb.Width + 5;
			wizBtn.Width = 55;
			wizBtn.Top = ( toolBarSep1.Rectangle.Height - wizBtn.Height ) / 2 + 1;

			ctrlToolbar.Controls.Add( wizBtn );

			// set the tab indexes in order to determine the focus.

			ctrlCodePane.TabIndex = 0;
			wizCb.TabIndex = 1;

			// return.

			return;
		}

		private void wizBtn_Click( object sender, LinkLabelLinkClickedEventArgs e )
		{
			ComboBox			cb = (ComboBox) ctrlToolbar.Controls[ 1 ];

			if ( cb.SelectedIndex == 0 )
			{
				// show a dlg.
				MessageBox.Show(
					"In order to use the \"Filter Code Wizard\" and the \"C# Window\" features, you should know a bit of the C# language.\n\nFrom the \"C# Window\" dialog you can setup a filter logic for the incoming and outcoming packets passing through the selected adapters. The code defined in the \"ProcessNextPacket\" function is called in the following conditions:\n\n(x) when a new packet arrives or is sent through the specified adapters.\n(x) when loading a packet set file (from the File->Open dialog). In this case each packet read from the file is filtered by the \"ProcessNextPacket\" function logic that can be defined here.\n\nConversely the \"Filter Code Wizard\" feature of NDIS Monitor is a tool that can be used for generating filter code logic on the fly. By selecting the desired filter from the wizard combo box, it is possible to generate filter code for new packets on the fly. The generated code is inserted at the current cursor position inside the code window.",
					"NDIS Monitor HELP for Filter Code Wizard" );
			}
			else
			{
				// wizard code.
				FilterWizard.Create( cb, ctrlCodePane );

				// set focus.
				ctrlCodePane.Focus ();
			}
		}
	}
}
