using System;
using NdisMonitor;
using System.Windows.Forms;

namespace NdisMonitor
{
	//
	// The definition of the attribute that has to be associated to an Extension Class.
	//

	[ AttributeUsage( AttributeTargets.Class, AllowMultiple = false, Inherited = false ) ]
	public class ExtensionAttribute : System.Attribute
	{
		// construction.
		public ExtensionAttribute ( string name )
		{
			this._name = name;
		}

		// data.
		protected string			_name = "";

		// public properties.
		public string Name
		{
			get
			{
				return _name;
			}
		}
	}

	//
	// The definition of the interface that an Extension Class has to implement.
	//

	public delegate void LogFn( string s );

	public delegate bool ProcessNextPacketFn( RawPacket rp, NdisHookStubs.NEXT_PACKET np, int ord, DateTime tm );
	public delegate bool UserCommandFn( string s );

	public interface INmExtension
	{
		bool ProcessNextPacket( RawPacket rp, NdisHookStubs.NEXT_PACKET np, int ord, DateTime tm );

		void Showing ( LogFn logFn, NdisHookStubs.NT_PROTOCOL_LIST protList, MenuItem popupMenu );
		void Hiding ();

		void DeleteAllPackets ();
		void Disposing ();

		bool UserCommand( string s );
	}
}
