using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Reflection;

namespace NdisMonitor
{
	/// <summary>
	/// Summary description for FilterWizard.
	/// </summary>
	public class FilterWizard : System.Windows.Forms.Form
	{
		private System.Windows.Forms.Panel ctrlContainer;
		private System.Windows.Forms.Label ctrlType;
		private System.Windows.Forms.Button ctrlGenerate;
		private System.Windows.Forms.Label label1;
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;

		public FilterWizard()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

			//
			// TODO: Add any constructor code after InitializeComponent call
			//
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if(components != null)
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			System.Resources.ResourceManager resources = new System.Resources.ResourceManager(typeof(FilterWizard));
			this.ctrlContainer = new System.Windows.Forms.Panel();
			this.ctrlType = new System.Windows.Forms.Label();
			this.ctrlGenerate = new System.Windows.Forms.Button();
			this.label1 = new System.Windows.Forms.Label();
			this.SuspendLayout();
			// 
			// ctrlContainer
			// 
			this.ctrlContainer.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left) 
				| System.Windows.Forms.AnchorStyles.Right)));
			this.ctrlContainer.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle;
			this.ctrlContainer.Location = new System.Drawing.Point(0, 40);
			this.ctrlContainer.Name = "ctrlContainer";
			this.ctrlContainer.Size = new System.Drawing.Size(360, 168);
			this.ctrlContainer.TabIndex = 0;
			// 
			// ctrlType
			// 
			this.ctrlType.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left) 
				| System.Windows.Forms.AnchorStyles.Right)));
			this.ctrlType.Location = new System.Drawing.Point(0, 0);
			this.ctrlType.Name = "ctrlType";
			this.ctrlType.Size = new System.Drawing.Size(360, 40);
			this.ctrlType.TabIndex = 1;
			this.ctrlType.Text = "label1";
			this.ctrlType.TextAlign = System.Drawing.ContentAlignment.MiddleCenter;
			// 
			// ctrlGenerate
			// 
			this.ctrlGenerate.Location = new System.Drawing.Point(280, 224);
			this.ctrlGenerate.Name = "ctrlGenerate";
			this.ctrlGenerate.TabIndex = 2;
			this.ctrlGenerate.Text = "Generate !";
			this.ctrlGenerate.Click += new System.EventHandler(this.ctrlGenerate_Click);
			// 
			// label1
			// 
			this.label1.Location = new System.Drawing.Point(8, 216);
			this.label1.Name = "label1";
			this.label1.Size = new System.Drawing.Size(216, 32);
			this.label1.TabIndex = 3;
			this.label1.Text = "Note that the code will be pasted at the current cursor position ...";
			this.label1.TextAlign = System.Drawing.ContentAlignment.MiddleCenter;
			// 
			// FilterWizard
			// 
			this.AcceptButton = this.ctrlGenerate;
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(360, 255);
			this.Controls.Add(this.label1);
			this.Controls.Add(this.ctrlGenerate);
			this.Controls.Add(this.ctrlType);
			this.Controls.Add(this.ctrlContainer);
			this.FormBorderStyle = System.Windows.Forms.FormBorderStyle.FixedDialog;
			this.Icon = ((System.Drawing.Icon)(resources.GetObject("$this.Icon")));
			this.MaximizeBox = false;
			this.MinimizeBox = false;
			this.Name = "FilterWizard";
			this.StartPosition = System.Windows.Forms.FormStartPosition.CenterScreen;
			this.Text = "Filter Code Wizard";
			this.Load += new System.EventHandler(this.FilterWizard_Load);
			this.ResumeLayout(false);

		}
		#endregion

		//
		// WIZ CTRLS.
		//

		protected const string			_descr00 = "must be Ethernet/TCP, incoming at a specific DEST port.";
		protected const string			_descr01 = "must be Ethernet/TCP, outcoming to a specific DEST port and/or IP addr.";
		protected const string			_descr02 = "must be Ethernet/UDP, incoming at a specific DEST port.";
		protected const string			_descr03 = "must be Ethernet/UDP, outcoming to a specific DEST port and/or IP addr.";
		protected const string			_descr04 = "must contain a particular byte sequence.";

		internal struct SWizCtrl
		{
			// constr.
			internal SWizCtrl( string _desc, string _type )
			{
				desc = _desc;
				type = _type;
			}

			// data.
			public string			desc;
			public string			type;

			// methods.
			public override string ToString ()
			{
				return desc;
			}
		}

		internal interface IWizCtrl
		{
			void Init ( SWizCtrl info );
			void Generate ( TextBox tb );
		}

		//
		// STATIC METHODS.
		//

		public static void PopulateCb( ComboBox cb )
		{
			// populate.
			cb.Items.Add( new SWizCtrl( _descr00, "FilterWizCtrl00" ) ); //1
			cb.Items.Add( new SWizCtrl( _descr01, "FilterWizCtrl01" ) ); //2
			cb.Items.Add( new SWizCtrl( _descr02, "FilterWizCtrl02" ) ); //3
			cb.Items.Add( new SWizCtrl( _descr03, "FilterWizCtrl03" ) ); //4
			cb.Items.Add( new SWizCtrl( _descr04, "FilterWizCtrl04" ) ); //5
		}

		public static void Create( ComboBox cb, TextBox tb )
		{
			// which case ?
			if ( cb.SelectedIndex > 0 )
			{
				SWizCtrl			ctrl = (SWizCtrl) cb.SelectedItem;

				// instance.

				FilterWizard		dlg = new FilterWizard ();
				dlg.SetInfo( ctrl, tb );
				dlg.ShowDialog ();
			}
		}

		//
		// METHODS.
		//

		internal void SetInfo( SWizCtrl ctrl, TextBox tb )
		{
			_ctrl = ctrl;
			_tb = tb;
		}

		private void FilterWizard_Load(object sender, System.EventArgs e)
		{
			// set window.

			ctrlType.Text = "Type: " + _ctrl.desc;

			UserControl		uc =
				(UserControl) Activator.CreateInstance( Type.GetType( "NdisMonitor." + _ctrl.type ) );

			ctrlContainer.Controls.Add( uc );

			// init.

			( (IWizCtrl) uc ).Init ( _ctrl );

			// return.

			return;
		}

		private void ctrlGenerate_Click(object sender, System.EventArgs e)
		{
			// call the impl.

			IWizCtrl		ctrl = (IWizCtrl) ctrlContainer.Controls[ 0 ];
			ctrl.Generate( _tb );

			// close.

			Close ();

			// set focus.

			_tb.Focus ();
		}

		//
		// DATA.
		//

		SWizCtrl			_ctrl;
		TextBox				_tb = null;
	}
}
